/*
 * PlotterProvider.java
 *
 * Created on January 14, 2003, 2:21 PM
 */

package org.freehep.jas.services;

/** An interface to be implemented by services which provide Plotters
 * @author tonyj
 */
public interface PlotterProvider
{
   /** Test if a given class of data is supported
    * @param klass The type of data to test for
    * @return <CODE>true</CODE> if this data type is supported
    */   
   boolean supports(Class klass);
   /** Create a plotter.
    * @return The newly created Plotter.
    */   
   Plotter create();
}
