package org.freehep.jas.services;

import java.net.URL;
import java.io.IOException;

/**
 * An interface to be implemented by services which can open URLs.
 * 
 * @author tonyj
 * @version $Id: URLHandler.java 13876 2011-09-20 00:52:21Z tonyj $
 */
public interface URLHandler
{
   /**
    * Returns true if this url handler is able to open the url
    * @param file The file to test
    * @return true if file can be opened.
    */
   boolean accept(URL url) throws IOException;

   /**
    * Opens a given url.
    * @param url The URL to open
    */
   void openURL(URL url) throws IOException;

}
